package $package;

import javax.jws.WebService;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.ow2.weblab.core.model.Resource;
import org.ow2.weblab.core.services.AccessDeniedException;
import org.ow2.weblab.core.services.ContentNotAvailableException;
import org.ow2.weblab.core.services.InsufficientResourcesException;
import org.ow2.weblab.core.services.InvalidParameterException;
import org.ow2.weblab.core.services.ReportProvider;
import org.ow2.weblab.core.services.ServiceNotConfiguredException;
import org.ow2.weblab.core.services.UnexpectedException;
import org.ow2.weblab.core.services.UnsupportedRequestException;
import org.ow2.weblab.core.services.reportprovider.AddInformationArgs;
import org.ow2.weblab.core.services.reportprovider.AddInformationReturn;
import org.ow2.weblab.core.services.reportprovider.BuildReportArgs;
import org.ow2.weblab.core.services.reportprovider.BuildReportReturn;

/**
 * Template for WebLab service which uses ReportProvider interface
 * 
 * @author WebLab Team
 */
@WebService(endpointInterface = "org.ow2.weblab.core.services.ReportProvider")
public class $className implements ReportProvider {


	/**
	 * The instance of logger used inside $className
	 */
	private final Log logger;


	/**
	 * Constructor
	 */
	public $className() {
		this.logger = LogFactory.getLog(this.getClass());

		// TODO Initialise other fields if needed

		this.logger.info("Service $className successfully started");
	}


	@Override
	public AddInformationReturn addInformation(final AddInformationArgs args) throws AccessDeniedException, ContentNotAvailableException,
			InsufficientResourcesException, InvalidParameterException, ServiceNotConfiguredException, UnexpectedException, UnsupportedRequestException {
		this.logger.debug("Early start of addInformation method.");

		final Resource resource = this.checkAddInformationArgs(args);

		this.logger.info("Start processing resource " + resource.getUri() + ".");

		// TODO Implement your method here!

		this.logger.error("Method addInformation not yet implemented.");
		throw new UnsupportedRequestException("Method addInformation not yet implemented.");
	}


	protected Resource checkAddInformationArgs(AddInformationArgs args) throws InvalidParameterException {
		if (args == null) {
			throw new InvalidParameterException("AddInformationArgs is null.");
		}
		final Resource resource = args.getResource();
		if (resource == null) {
			throw new InvalidParameterException("Resource in AddInformationArgs is null.");
		}

		// TODO Maybe implement a better test for your resource (for instance, is a Document required?)
		// TODO Test the existence of an usageContext if required

		return resource;
	}


	@Override
	public BuildReportReturn buildReport(final BuildReportArgs args) throws AccessDeniedException, ContentNotAvailableException,
			InsufficientResourcesException, InvalidParameterException, ServiceNotConfiguredException, UnexpectedException, UnsupportedRequestException {
		this.logger.debug("Early start of buildReport method.");

		this.checkBuildReportArgs(args);

		// TODO Implement your method here!

		this.logger.error("Method buildReport not yet implemented.");
		throw new UnsupportedRequestException("Method buildReport not yet implemented.", "Constructor not yet implemented.");
	}


	protected void checkBuildReportArgs(BuildReportArgs args) throws InvalidParameterException {
		if (args == null) {
			throw new InvalidParameterException("BuildReportArgs is null.");
		}
	}

}
