package $package;

import org.junit.Before;
import org.junit.Test;
import org.ow2.weblab.core.services.InvalidParameterException;
import org.ow2.weblab.core.services.reportprovider.AddInformationArgs;

/**
 * Template for WebLab service test which uses ReportProvider interface
 * 
 * @author WebLab Team
 */
public class $classNameTest {


	/**
	 * Instance of service which implement a ReportProvider
	 */
	private $className reportProvider;


	/**
	 * Initialisation before tests
	 */
	@Before
	public void init() {
		this.reportProvider = new $className();
	}


	/**
	 * Exception tests
	 */
	@Test(expected = InvalidParameterException.class)
	public void testNullAddInformationArgs() throws Exception {
		this.reportProvider = new $className();
		this.reportProvider.addInformation(null);
	}


	/**
	 * Exception tests
	 */
	@Test(expected = InvalidParameterException.class)
	public void testNullResourceAddInformationArgs() throws Exception {
		this.reportProvider = new $className();
		this.reportProvider.addInformation(new AddInformationArgs());
	}


	/**
	 * Exception tests
	 */
	@Test(expected = InvalidParameterException.class)
	public void testNullBuildReportArgs() throws Exception {
		this.reportProvider = new $className();
		this.reportProvider.buildReport(null);
	}

}